diff --git a/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c b/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c
index 3715e98..7a28107 100644
--- a/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c
+++ b/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.c
@@ -1942,17 +2076,14 @@ static int q931_rx_32(void *pvt, Q921DLMsg_t ind, L3UCHAR tei, L3UCHAR *msg, L3I
 		break;
 	}
 
-	return Q921Rx32(pvt, ind, tei, msg, mlen);
+#ifdef HAVE_PCAP
+	if (isdn_pcap_capture_l3only(isdn_data)) {
+		isdn_pcap_write(isdn_data, msg, mlen, ISDN_PCAP_OUTGOING);
+	}
+#endif
+	return Q921Rx32(&isdn_data->q921, ind, tei, msg, mlen);
 }
 
-/**
- * \brief Logs Q921 message
- * \param pvt Span were message is coming from
- * \param level Q921 log level
- * \param msg Message string
- * \param size Message string length
- * \return 0
- */
 static int ftdm_isdn_q921_log(void *pvt, Q921LogLevel_t level, char *msg, L2INT size)
 {
 	ftdm_span_t *span = (ftdm_span_t *) pvt;
@@ -1961,14 +2092,6 @@ static int ftdm_isdn_q921_log(void *pvt, Q921LogLevel_t level, char *msg, L2INT
 	return 0;
 }
 
-/**
- * \brief Logs Q931 message
- * \param pvt Span were message is coming from
- * \param level Q931 log level
- * \param msg Message string
- * \param size Message string length
- * \return 0
- */
 static L3INT ftdm_isdn_q931_log(void *pvt, Q931LogLevel_t level, char *msg, L3INT size)
 {
 	ftdm_span_t *span = (ftdm_span_t *) pvt;
@@ -1976,9 +2099,7 @@ static L3INT ftdm_isdn_q931_log(void *pvt, Q931LogLevel_t level, char *msg, L3IN
 	ftdm_log("Span", "Q.931", span->span_id, (int)level, "%s", msg);
 	return 0;
 }
-/**
- * \brief ISDN state map
- */
+
 static ftdm_state_map_t isdn_state_map = {
 	{
 		{
@@ -2003,7 +2124,7 @@ static ftdm_state_map_t isdn_state_map = {
 			ZSD_OUTBOUND,
 			ZSM_UNACCEPTABLE,
 			{FTDM_CHANNEL_STATE_DIALING, FTDM_END},
-			{FTDM_CHANNEL_STATE_PROGRESS_MEDIA, FTDM_CHANNEL_STATE_PROGRESS, FTDM_CHANNEL_STATE_UP, FTDM_CHANNEL_STATE_HANGUP, FTDM_CHANNEL_STATE_TERMINATING, FTDM_END}
+			{FTDM_CHANNEL_STATE_PROGRESS_MEDIA, FTDM_CHANNEL_STATE_PROGRESS, FTDM_CHANNEL_STATE_UP, FTDM_CHANNEL_STATE_HANGUP, FTDM_CHANNEL_STATE_TERMINATING, FTDM_CHANNEL_STATE_DOWN, FTDM_END}
 		},
 		{
 			ZSD_OUTBOUND,
@@ -2077,7 +2198,7 @@ static ftdm_state_map_t isdn_state_map = {
 			ZSD_INBOUND,
 			ZSM_UNACCEPTABLE,
 			{FTDM_CHANNEL_STATE_PROGRESS, FTDM_CHANNEL_STATE_PROGRESS_MEDIA, FTDM_END},
-			{FTDM_CHANNEL_STATE_HANGUP, FTDM_CHANNEL_STATE_TERMINATING, FTDM_CHANNEL_STATE_PROGRESS_MEDIA, 
+			{FTDM_CHANNEL_STATE_HANGUP, FTDM_CHANNEL_STATE_TERMINATING, FTDM_CHANNEL_STATE_PROGRESS_MEDIA,
 			 FTDM_CHANNEL_STATE_CANCEL, FTDM_CHANNEL_STATE_UP, FTDM_END},
 		},
 		{
@@ -2086,17 +2207,11 @@ static ftdm_state_map_t isdn_state_map = {
 			{FTDM_CHANNEL_STATE_UP, FTDM_END},
 			{FTDM_CHANNEL_STATE_HANGUP, FTDM_CHANNEL_STATE_TERMINATING, FTDM_END},
 		},
-		
-
 	}
 };
 
 /**
- * \brief Stops an ISDN span
- * \param span Span to halt
- * \return Success
- *
- * Sets a stop flag and waits for the threads to end
+ * \brief	Stop signalling on span
  */
 static ftdm_status_t ftdm_isdn_stop(ftdm_span_t *span)
 {
@@ -2105,9 +2220,9 @@ static ftdm_status_t ftdm_isdn_stop(ftdm_span_t *span)
 	if (!ftdm_test_flag(isdn_data, FTDM_ISDN_RUNNING)) {
 		return FTDM_FAIL;
 	}
-		
+
 	ftdm_set_flag(isdn_data, FTDM_ISDN_STOP);
-	
+
 	while(ftdm_test_flag(isdn_data, FTDM_ISDN_RUNNING)) {
 		ftdm_sleep(100);
 	}
@@ -2117,15 +2232,10 @@ static ftdm_status_t ftdm_isdn_stop(ftdm_span_t *span)
 	}
 
 	return FTDM_SUCCESS;
-	
 }
 
 /**
- * \brief Starts an ISDN span
- * \param span Span to halt
- * \return Success or failure
- *
- * Launches a thread to monitor the span and a thread to generate tones on the span
+ * \brief	Start signalling on span
  */
 static ftdm_status_t ftdm_isdn_start(ftdm_span_t *span)
 {
@@ -2149,19 +2259,46 @@ static ftdm_status_t ftdm_isdn_start(ftdm_span_t *span)
 	return ret;
 }
 
-/**
- * \brief Parses an option string to flags
- * \param in String to parse for configuration options
- * \return Flags
- */
+
+/*###################################################################*
+ * (text) value parsing / translation
+ *###################################################################*/
+
+static int32_t parse_loglevel(const char *level)
+{
+	if (!level) {
+		return -1;
+	}
+
+	if (!strcasecmp(level, "debug")) {
+		return FTDM_LOG_LEVEL_DEBUG;
+	} else if (!strcasecmp(level, "info")) {
+		return FTDM_LOG_LEVEL_INFO;
+	} else if (!strcasecmp(level, "notice")) {
+		return FTDM_LOG_LEVEL_NOTICE;
+	} else if (!strcasecmp(level, "warning")) {
+		return FTDM_LOG_LEVEL_WARNING;
+	} else if (!strcasecmp(level, "error")) {
+		return FTDM_LOG_LEVEL_ERROR;
+	} else if (!strcasecmp(level, "alert")) {
+		return FTDM_LOG_LEVEL_ALERT;
+	} else if (!strcasecmp(level, "crit")) {
+		return FTDM_LOG_LEVEL_CRIT;
+	} else if (!strcasecmp(level, "emerg")) {
+		return FTDM_LOG_LEVEL_EMERG;
+	} else {
+		return -1;
+	}
+}
+
 static uint32_t parse_opts(const char *in)
 {
 	uint32_t flags = 0;
-	
+
 	if (!in) {
 		return 0;
 	}
-	
+
 	if (strstr(in, "suggest_channel")) {
 		flags |= FTDM_ISDN_OPT_SUGGEST_CHANNEL;
 	}
@@ -2177,17 +2314,259 @@ static uint32_t parse_opts(const char *in)
 	return flags;
 }
 
+static uint32_t parse_dialect(const char *in)
+{
+	if (!in) {
+		return Q931_Dialect_Count;
+	}
+
+#if __UNSUPPORTED__
+	if (!strcasecmp(in, "national")) {
+		return Q931_Dialect_National;
+	}
+	if (!strcasecmp(in, "dms")) {
+		return Q931_Dialect_DMS;
+	}
+#endif
+	if (!strcasecmp(in, "5ess")) {
+		return Q931_Dialect_5ESS;
+	}
+	if (!strcasecmp(in, "dss1")) {
+		return Q931_Dialect_DSS1;
+	}
+	if (!strcasecmp(in, "q931")) {
+		return Q931_Dialect_Q931;
+	}
+	return Q931_Dialect_Count;
+}
+
+
+/*###################################################################*
+ * API commands
+ *###################################################################*/
+
+static const char isdn_api_usage[] =
+#ifdef HAVE_PCAP
+	"isdn capture <span> <start> <filename> [q931only]\n"
+	"isdn capture <span> <stop|suspend|resume>\n"
+#endif
+	"isdn loglevel <span> <q921|q931|all> <loglevel>\n"
+	"isdn dump <span> calls\n"
+	"isdn help";
+
+
 /**
- * \brief Initialises an ISDN span from configuration variables
- * \param span Span to configure
- * \param sig_cb Callback function for event signals
- * \param ap List of configuration variables
- * \return Success or failure
+ * isdn_api
  */
-static FIO_SIG_CONFIGURE_FUNCTION(ftdm_isdn_configure_span)
+static FIO_API_FUNCTION(isdn_api)
+{
+	char *mycmd = NULL, *argv[10] = { 0 };
+	int argc = 0;
+
+	if (data) {
+		mycmd = strdup(data);
+		argc = ftdm_separate_string(mycmd, ' ', argv, (sizeof(argv) / sizeof(argv[0])));
+	}
+
+	if (!argc || !strcasecmp(argv[0], "help")) {
+		stream->write_function(stream, "%s\n", isdn_api_usage);
+		goto done;
+	}
+	else if (!strcasecmp(argv[0], "dump")) {
+		ftdm_isdn_data_t *isdn_data = NULL;
+		ftdm_span_t *span = NULL;
+		int span_id = 0;
+
+		/* dump <span> calls */
+
+		if (argc < 3) {
+			stream->write_function(stream, "-ERR not enough arguments.\n");
+			goto done;
+		}
+
+		span_id = atoi(argv[1]);
+
+		if (ftdm_span_find_by_name(argv[1], &span) == FTDM_SUCCESS || ftdm_span_find(span_id, &span) == FTDM_SUCCESS) {
+			isdn_data = span->signal_data;
+		} else {
+			stream->write_function(stream, "-ERR invalid span.\n");
+			goto done;
+		}
+
+		if (!strcasecmp(argv[2], "calls")) {
+			/* dump all calls to log */
+			Q931DumpAllCalls(&isdn_data->q931);
+			stream->write_function(stream, "+OK call information dumped to log\n");
+			goto done;
+		}
+	}
+	else if (!strcasecmp(argv[0], "loglevel")) {
+		ftdm_isdn_data_t *isdn_data = NULL;
+		ftdm_span_t *span = NULL;
+		int span_id = 0;
+		int layer   = 0;
+		int level   = 0;
+
+		/* loglevel <span> <q921|q931|all> [level] */
+
+		if (argc < 3) {
+			stream->write_function(stream, "-ERR not enough arguments.\n");
+			goto done;
+		}
+
+		span_id = atoi(argv[1]);
+
+		if (ftdm_span_find_by_name(argv[1], &span) == FTDM_SUCCESS || ftdm_span_find(span_id, &span) == FTDM_SUCCESS) {
+			isdn_data = span->signal_data;
+		} else {
+			stream->write_function(stream, "-ERR invalid span.\n");
+			goto done;
+		}
+
+		if (!strcasecmp(argv[2], "q921")) {
+			layer = 0x01;
+		} else if(!strcasecmp(argv[2], "q931")) {
+			layer = 0x02;
+		} else if (!strcasecmp(argv[2], "all")) {
+			layer = 0x03;
+		} else {
+			stream->write_function(stream, "-ERR invalid layer\n");
+			goto done;
+		}
+
+		if (argc > 3) {
+			/* set loglevel  */
+			if ((level = parse_loglevel(argv[3])) < 0) {
+				stream->write_function(stream, "-ERR invalid loglevel\n");
+				goto done;
+			}
+
+			if (layer & 0x01) {	/* q921 */
+				Q921SetLogLevel(&isdn_data->q921, (Q921LogLevel_t)level);
+			}
+			if (layer & 0x02) {	/* q931 */
+				Q931SetLogLevel(&isdn_data->q931, (Q931LogLevel_t)level);
+			}
+			stream->write_function(stream, "+OK loglevel set");
+		} else {
+			/* get loglevel */
+			if (layer & 0x01) {
+				stream->write_function(stream, "Q.921 loglevel: %s\n",
+					Q921GetLogLevelName(&isdn_data->q921));
+			}
+			if (layer & 0x02) {
+				stream->write_function(stream, "Q.931 loglevel: %s\n",
+					Q931GetLogLevelName(&isdn_data->q931));
+			}
+			stream->write_function(stream, "+OK");
+		}
+		goto done;
+	}
+#ifdef HAVE_PCAP
+	else if (!strcasecmp(argv[0], "capture")) {
+		ftdm_isdn_data_t *isdn_data = NULL;
+		ftdm_span_t *span = NULL;
+		int span_id = 0;
+
+		/* capture <span> <start> <filename> [q931only] */
+		/* capture <span> <stop|suspend|resume> */
+
+		if (argc < 3) {
+			stream->write_function(stream, "-ERR not enough arguments.\n");
+			goto done;
+		}
+
+		span_id = atoi(argv[1]);
+
+		if (ftdm_span_find_by_name(argv[1], &span) == FTDM_SUCCESS || ftdm_span_find(span_id, &span) == FTDM_SUCCESS) {
+			isdn_data = span->signal_data;
+		} else {
+			stream->write_function(stream, "-ERR invalid span.\n");
+			goto done;
+		}
+
+		if (!strcasecmp(argv[2], "start")) {
+			char *filename = NULL;
+
+			if (argc < 4) {
+				stream->write_function(stream, "-ERR not enough parameters.\n");
+				goto done;
+			}
+
+			if (isdn_pcap_is_open(isdn_data)) {
+				stream->write_function(stream, "-ERR capture is already running.\n");
+				goto done;
+			}
+
+			filename = argv[3];
+
+			if (isdn_pcap_open(isdn_data, filename) != FTDM_SUCCESS) {
+				stream->write_function(stream, "-ERR failed to open capture file.\n");
+				goto done;
+			}
+
+			if (argc > 4 && !strcasecmp(argv[4], "q931only")) {
+				isdn_data->flags |= FTDM_ISDN_CAPTURE_L3ONLY;
+			}
+			isdn_pcap_start(isdn_data);
+
+			stream->write_function(stream, "+OK capture started.\n");
+			goto done;
+		}
+		else if(!strcasecmp(argv[2], "stop")) {
+
+			if (!isdn_pcap_is_open(isdn_data)) {
+				stream->write_function(stream, "-ERR capture is not running.\n");
+				goto done;
+			}
+
+			isdn_pcap_stop(isdn_data);
+			isdn_pcap_close(isdn_data);
+
+			stream->write_function(stream, "+OK capture stopped.\n");
+			goto done;
+		}
+		else if(!strcasecmp(argv[2], "suspend")) {
+
+			if (!isdn_pcap_is_open(isdn_data)) {
+				stream->write_function(stream, "-ERR capture is not running.\n");
+				goto done;
+			}
+			isdn_pcap_stop(isdn_data);
+
+			stream->write_function(stream, "+OK capture suspended.\n");
+			goto done;
+		}
+		else if(!strcasecmp(argv[2], "resume")) {
+
+			if (!isdn_pcap_is_open(isdn_data)) {
+				stream->write_function(stream, "-ERR capture is not running.\n");
+				goto done;
+			}
+			isdn_pcap_start(isdn_data);
+
+			stream->write_function(stream, "+OK capture resumed.\n");
+			goto done;
+		}
+		else {
+			stream->write_function(stream, "-ERR wrong action.\n");
+			goto done;
+		}
+	}
+#endif
+	else {
+		stream->write_function(stream, "-ERR invalid command.\n");
+	}
+done:
+	ftdm_safe_free(mycmd);
+
+	return FTDM_SUCCESS;
+}
+
+static FIO_SIG_CONFIGURE_FUNCTION(isdn_configure_span)
 {
 	uint32_t i, x = 0;
-	ftdm_channel_t *dchans[2] = {0};
+	ftdm_channel_t *dchans[2] = { 0 };
 	ftdm_isdn_data_t *isdn_data;
 	const char *tonemap = "us";
 	char *var, *val;
@@ -2195,40 +2574,8 @@ static FIO_SIG_CONFIGURE_FUNCTION(ftdm_isdn_configure_span)
 	int32_t digit_timeout = 0;
 	int q921loglevel = -1;
 	int q931loglevel = -1;
-#ifdef HAVE_LIBPCAP
-	int q931topcap   = -1; 	/*Q931ToPcap*/
-	int openPcap = 0; 	/*Flag: open Pcap file please*/
-#endif
 
 	if (span->signal_type) {
-#ifdef HAVE_LIBPCAP
-		/*Q931ToPcap: Get the content of the q931topcap and pcapfilename args given by mod_freetdm */
-		while((var = va_arg(ap, char *))) {
-			if (!strcasecmp(var, "q931topcap")) {
-				q931topcap = va_arg(ap, int);
-				if(q931topcap==1) {
-					/*PCAP on*/;
-					openPcap=1;
-				} else if (q931topcap==0) {
-					/*PCAP off*/
-					if (closePcapFile() != FTDM_SUCCESS) return FTDM_FAIL;
-					do_q931ToPcap=0;
-					return FTDM_SUCCESS;
-				}
-			}
-			if (!strcasecmp(var, "pcapfilename")) {
-				/*Put filename into global var*/
-				pcapfn = va_arg(ap, char*);
-			}
-		}
-		/*We know now, that user wants to enable Q931ToPcap and what file name he wants, so open it please*/
-		if(openPcap==1){
-			if(openPcapFile() != FTDM_SUCCESS) return FTDM_FAIL;
-			do_q931ToPcap=1;
-			return FTDM_SUCCESS;
-		}
-		/*Q931ToPcap done*/
-#endif
 		snprintf(span->last_error, sizeof(span->last_error), "Span is already configured for signalling [%d].", span->signal_type);
 		return FTDM_FAIL;
 	}
@@ -2237,34 +2584,33 @@ static FIO_SIG_CONFIGURE_FUNCTION(ftdm_isdn_configure_span)
 		ftdm_log(FTDM_LOG_WARNING, "Invalid trunk type '%s' defaulting to T1.\n", ftdm_trunk_type2str(span->trunk_type));
 		span->trunk_type = FTDM_TRUNK_T1;
 	}
-	
+
 	for(i = 1; i <= span->chan_count; i++) {
 		if (span->channels[i]->type == FTDM_CHAN_TYPE_DQ921) {
 			if (x > 1) {
 				snprintf(span->last_error, sizeof(span->last_error), "Span has more than 2 D-Channels!");
 				return FTDM_FAIL;
-			} else {
-				if (ftdm_channel_open(span->span_id, i, &dchans[x]) == FTDM_SUCCESS) {
-					ftdm_log(FTDM_LOG_DEBUG, "opening d-channel #%d %d:%d\n", x, dchans[x]->span_id, dchans[x]->chan_id);
-					dchans[x]->state = FTDM_CHANNEL_STATE_UP;
-					x++;
-				}
+			}
+
+			if (ftdm_channel_open(span->span_id, i, &dchans[x]) == FTDM_SUCCESS) {
+				ftdm_log(FTDM_LOG_DEBUG, "opening d-channel #%d %d:%d\n", x, dchans[x]->span_id, dchans[x]->chan_id);
+				dchans[x]->state = FTDM_CHANNEL_STATE_UP;
+				x++;
 			}
 		}
 	}
-
 	if (!x) {
 		snprintf(span->last_error, sizeof(span->last_error), "Span has no D-Channels!");
 		return FTDM_FAIL;
 	}
 
-	isdn_data = ftdm_malloc(sizeof(*isdn_data));
+	isdn_data = malloc(sizeof(*isdn_data));
 	assert(isdn_data != NULL);
 	memset(isdn_data, 0, sizeof(*isdn_data));
-	
+
 	isdn_data->mode = Q931_TE;
-	dialect = Q931_Dialect_National;
-	
+	dialect = Q931_Dialect_Q931;
+
 	while((var = va_arg(ap, char *))) {
 		if (!strcasecmp(var, "mode")) {
 			if (!(val = va_arg(ap, char *))) {
@@ -2275,8 +2621,9 @@ static FIO_SIG_CONFIGURE_FUNCTION(ftdm_isdn_configure_span)
 			if (!(val = va_arg(ap, char *))) {
 				break;
 			}
-			dialect = q931_str2Q931Dialect_type(val);
+			dialect = parse_dialect(val);
 			if (dialect == Q931_Dialect_Count) {
+				snprintf(span->last_error, sizeof(span->last_error), "Invalid/unknown dialect [%s]!", val);
 				return FTDM_FAIL;
 			}
 		} else if (!strcasecmp(var, "opts")) {
@@ -2315,7 +2662,6 @@ static FIO_SIG_CONFIGURE_FUNCTION(ftdm_isdn_configure_span)
 		}
 	}
 
-
 	if (!digit_timeout) {
 		digit_timeout = DEFAULT_DIGIT_TIMEOUT;
 	}
@@ -2328,7 +2674,7 @@ static FIO_SIG_CONFIGURE_FUNCTION(ftdm_isdn_configure_span)
 	if (isdn_data->mode == Q931_NT) {
 		ftdm_isdn_bchan_data_t *data;
 
-		data = ftdm_malloc((span->chan_count - 1) * sizeof(ftdm_isdn_bchan_data_t));
+		data = malloc(span->chan_count * sizeof(ftdm_isdn_bchan_data_t));
 		if (!data) {
 			return FTDM_FAIL;
 		}
@@ -2340,15 +2686,13 @@ static FIO_SIG_CONFIGURE_FUNCTION(ftdm_isdn_configure_span)
 			}
 		}
 	}
-					
-	span->start = ftdm_isdn_start;
-	span->stop = ftdm_isdn_stop;
-	span->signal_cb = sig_cb;
+
+	isdn_data->sig_cb    = sig_cb;
 	isdn_data->dchans[0] = dchans[0];
 	isdn_data->dchans[1] = dchans[1];
-	isdn_data->dchan = isdn_data->dchans[0];
+	isdn_data->dchan     = isdn_data->dchans[0];
 	isdn_data->digit_timeout = digit_timeout;
-	
+
 	Q921_InitTrunk(&isdn_data->q921,
 				   0,
 				   0,
@@ -2358,55 +2702,104 @@ static FIO_SIG_CONFIGURE_FUNCTION(ftdm_isdn_configure_span)
 				   ftdm_isdn_921_21,
 				   (Q921Tx23CB_t)ftdm_isdn_921_23,
 				   span,
-				   &isdn_data->q931);
+				   span);
 
-	Q921SetLogCB(&isdn_data->q921, &ftdm_isdn_q921_log, isdn_data);
+	Q921SetLogCB(&isdn_data->q921, &ftdm_isdn_q921_log, span);
 	Q921SetLogLevel(&isdn_data->q921, (Q921LogLevel_t)q921loglevel);
-	
-	Q931Api_InitTrunk(&isdn_data->q931,
+
+	Q931InitTrunk(&isdn_data->q931,
 					  dialect,
 					  isdn_data->mode,
 					  span->trunk_type,
 					  ftdm_isdn_931_34,
 					  (Q931Tx32CB_t)q931_rx_32,
 					  ftdm_isdn_931_err,
-					  &isdn_data->q921,
+					  span,
 					  span);
 
-	Q931SetLogCB(&isdn_data->q931, &ftdm_isdn_q931_log, isdn_data);
+	Q931SetLogCB(&isdn_data->q931, &ftdm_isdn_q931_log, span);
 	Q931SetLogLevel(&isdn_data->q931, (Q931LogLevel_t)q931loglevel);
 
-	isdn_data->q931.autoRestartAck = 1;
-	isdn_data->q931.autoConnectAck = 0;
-	isdn_data->q931.autoServiceAck = 1;
-	span->signal_data = isdn_data;
-	span->signal_type = FTDM_SIGTYPE_ISDN;
+	/* Register new event hander CB */
+	Q931SetCallEventCB(&isdn_data->q931, ftdm_isdn_call_event, span);
+
+	/* TODO: hmm, maybe drop the "Trunk" prefix */
+	Q931TrunkSetAutoRestartAck(&isdn_data->q931, 1);
+	Q931TrunkSetAutoConnectAck(&isdn_data->q931, 1);
+	Q931TrunkSetAutoServiceAck(&isdn_data->q931, 1);
+	Q931TrunkSetStatusEnquiry(&isdn_data->q931, 0);
+
+	span->state_map     = &isdn_state_map;
+	span->signal_data   = isdn_data;
+	span->signal_type   = FTDM_SIGTYPE_ISDN;
+	span->start         = ftdm_isdn_start;
+	span->stop          = ftdm_isdn_stop;
 	span->outgoing_call = isdn_outgoing_call;
 
+	span->get_channel_sig_status = isdn_get_channel_sig_status;
+	span->get_span_sig_status    = isdn_get_span_sig_status;
+
+#ifdef __TODO__
 	if ((isdn_data->opts & FTDM_ISDN_OPT_SUGGEST_CHANNEL)) {
 		span->channel_request = isdn_channel_request;
-		ftdm_set_flag(span, FTDM_SPAN_SUGGEST_CHAN_ID);
+		span->flags |= FTDM_SPAN_SUGGEST_CHAN_ID;
 	}
-	span->state_map = &isdn_state_map;
-
+#endif
 	ftdm_span_load_tones(span, tonemap);
 
 	return FTDM_SUCCESS;
 }
 
 /**
- * \brief FreeTDM ISDN signaling module definition
+ * ISDN module io interface
+ * \note	This is really ugly...
  */
-EX_DECLARE_DATA ftdm_module_t ftdm_module = {
-	"isdn",
-	NULL,
-	close_pcap,
-	ftdm_isdn_init,
-	ftdm_isdn_configure_span,
-	NULL
+static ftdm_io_interface_t isdn_interface = {
+	.name = "isdn",
+	.api  = isdn_api
 };
 
+/**
+ * \brief	ISDN module io interface init callback
+ */
+static FIO_IO_LOAD_FUNCTION(isdn_io_load)
+{
+        assert(fio != NULL);
+
+        *fio = &isdn_interface;
+
+        return FTDM_SUCCESS;
+}
+
+/**
+ * \brief	ISDN module load callback
+ */
+static FIO_SIG_LOAD_FUNCTION(isdn_load)
+{
+	Q931Initialize();
+
+	Q921SetGetTimeCB(ftdm_time_now);
+	Q931SetGetTimeCB(ftdm_time_now);
+
+	return FTDM_SUCCESS;
+}
 
+/**
+ * \brief	ISDN module shutdown callback
+ */
+static FIO_SIG_UNLOAD_FUNCTION(isdn_unload)
+{
+	return FTDM_SUCCESS;
+};
+
+ftdm_module_t ftdm_module = {
+	.name          = "isdn",
+	.io_load       = isdn_io_load,
+	.io_unload     = NULL,
+	.sig_load      = isdn_load,
+	.sig_unload    = isdn_unload,
+	.sig_configure = isdn_configure_span
+};
 
 /* For Emacs:
  * Local Variables:
@@ -2416,5 +2809,5 @@ EX_DECLARE_DATA ftdm_module_t ftdm_module = {
  * c-basic-offset:4
  * End:
  * For VIM:
- * vim:set softtabstop=4 shiftwidth=4 tabstop=4:
+ * vim:set softtabstop=4 shiftwidth=4 tabstop=4 expandtab:
  */
diff --git a/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.h b/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.h
new file mode 100644
index 0000000..95eee90
--- /dev/null
+++ b/libs/freetdm/src/ftmod/ftmod_isdn/ftmod_isdn.h
@@ -0,0 +1,105 @@
+/*
+ * Copyright (c) 2007, Anthony Minessale II
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * * Redistributions of source code must retain the above copyright
+ * notice, this list of conditions and the following disclaimer.
+ *
+ * * Redistributions in binary form must reproduce the above copyright
+ * notice, this list of conditions and the following disclaimer in the
+ * documentation and/or other materials provided with the distribution.
+ *
+ * * Neither the name of the original author; nor the names of any contributors
+ * may be used to endorse or promote products derived from this software
+ * without specific prior written permission.
+ *
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+ * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
+ * OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+ * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+ * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
+ * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef FTDM_ISDN_H
+#define FTDM_ISDN_H
+
+#define DEFAULT_DIGIT_TIMEOUT	10000		/* default overlap timeout: 10 seconds */
+
+
+typedef enum {
+	FTDM_ISDN_OPT_NONE = 0,
+	FTDM_ISDN_OPT_SUGGEST_CHANNEL = (1 << 0),
+	FTDM_ISDN_OPT_OMIT_DISPLAY_IE = (1 << 1),	/*!< Do not send Caller name in outgoing SETUP message (= Display IE) */
+	FTDM_ISDN_OPT_DISABLE_TONES   = (1 << 2),	/*!< Disable tone generating thread (NT mode) */
+
+	FTDM_ISDN_OPT_MAX = (2 << 0)
+} ftdm_isdn_opts_t;
+
+typedef enum {
+	FTDM_ISDN_RUNNING        = (1 << 0),
+	FTDM_ISDN_TONES_RUNNING  = (1 << 1),
+	FTDM_ISDN_STOP           = (1 << 2),
+
+	FTDM_ISDN_CAPTURE        = (1 << 3),
+	FTDM_ISDN_CAPTURE_L3ONLY = (1 << 4)
+} ftdm_isdn_flag_t;
+
+#ifdef HAVE_PCAP
+struct pcap_context;
+#endif
+
+struct ftdm_isdn_data {
+	Q921Data_t q921;
+	Q931_TrunkInfo_t q931;
+	ftdm_channel_t *dchan;
+	ftdm_channel_t *dchans[2];
+	struct ftdm_sigmsg sigmsg;
+	fio_signal_cb_t sig_cb;
+	uint32_t flags;
+	int32_t mode;
+	int32_t digit_timeout;
+	ftdm_isdn_opts_t opts;
+	ftdm_caller_data_t *outbound_crv[32768];
+	ftdm_channel_t *channels_local_crv[32768];
+	ftdm_channel_t *channels_remote_crv[32768];
+#ifdef HAVE_PCAP
+	struct pcap_context *pcap;
+#endif
+};
+
+typedef struct ftdm_isdn_data ftdm_isdn_data_t;
+
+
+/* b-channel private data */
+struct ftdm_isdn_bchan_data
+{
+	int32_t digit_timeout;
+};
+
+typedef struct ftdm_isdn_bchan_data ftdm_isdn_bchan_data_t;
+
+
+#endif
+
+/* For Emacs:
+ * Local Variables:
+ * mode:c
+ * indent-tabs-mode:t
+ * tab-width:4
+ * c-basic-offset:4
+ * End:
+ * For VIM:
+ * vim:set softtabstop=4 shiftwidth=4 tabstop=4 expandtab:
+ */
+
